;;; <%= @long_theme_name %>.el --- an Emacs 24 theme based on <%= @name %> (tmTheme)
;;
;;; Author: Auto Converted to Emacs 24 by tmtheme-to-deftheme (tm2deftheme)
;;; Version: <%= Time.now.to_i %>
;;; Original author: <%= @author %>
;;; Url: https://github.com/emacsfodder/tmtheme-to-deftheme
;;; Package-Requires: ((emacs "24.0"))
;;
;;; Commentary:
;;  This theme was automatically generated by tmtheme-to-deftheme (tm2deftheme),
;;  from <%= @name %> (tmTheme) by <%= @author %>
;;
;;; Code:

(deftheme <%= @theme_name %>
  "<%= @long_theme_name %> - Created by tmtheme-to-deftheme - <%= Time.now.to_s %>")

(custom-theme-set-variables
 '<%= @theme_name %>
)

(custom-theme-set-faces
 '<%= @theme_name %>
 ;; basic theming.

 '(default ((t (<%= face_attrs(@base_settings) %>))))
 '(region  ((t (:background "<%= @base_settings["selection"] %>"))))
 '(cursor  ((t (:background "<%= @base_settings["caret"] %>"))))

 ;; Temporary defaults
 <%
 # Linum and Fringe are generated from base_bg
 %>
 <% if darktheme? %>
 <% debug_out "Dark theme linum/fringe"  %>
 '(linum                               ((t (:foreground "<%= @base_bg.mix_with(@base_fg, 80).html %>"  :background "<%= @base_bg.mix_with(@base_fg, 90).html %>" ))))
 '(fringe                              ((t (                       :background "<%= @base_bg.mix_with(@base_fg, 90).html %>" ))))
 <% else %>
 <% debug_out "Light theme linum/fringe"  %>
 '(linum                               ((t (:foreground "<%= @base_fg.adjust_brightness(90).html %>"  :background "<%= @base_bg.adjust_brightness(-30).html %>" ))))
 '(fringe                              ((t (                       :background "<%= @base_bg.adjust_brightness(-30).html %>" ))))
 <% end %>

 '(minibuffer-prompt                   ((t (:foreground "#1278A8"  :background nil       :weight bold                                  ))))
 '(escape-glyph                        ((t (:foreground "orange"   :background nil                                                     ))))
 '(highlight                           ((t (:foreground "orange"   :background nil                                                     ))))
 '(shadow                              ((t (:foreground "#777777"  :background nil                                                     ))))

 '(trailing-whitespace                 ((t (:foreground "#FFFFFF"  :background "#C74000"                                               ))))
 '(link                                ((t (:foreground "#00b7f0"  :background nil       :underline t                                  ))))
 '(link-visited                        ((t (:foreground "#4488cc"                        :underline t :inherit (link)                  ))))
 '(button                              ((t (:foreground "#FFFFFF"  :background "#444444" :underline t :inherit (link)                  ))))
 '(next-error                          ((t (                                             :inherit (region)                             ))))
 '(query-replace                       ((t (                                             :inherit (isearch)                            ))))
 '(header-line                         ((t (:foreground "#EEEEEE"  :background "#444444" :box nil :inherit (mode-line)                 ))))

 <%
 # Modeline is generated from base_fg / base_bg
 %>
 '(mode-line-highlight                 ((t (                                             :box nil                                      ))))
 '(mode-line-emphasis                  ((t (                                             :weight bold                                  ))))
 '(mode-line-buffer-id                 ((t (                                             :box nil :weight bold                         ))))

<% if darktheme? %>
 <% debug_out "Dark theme modeline"  %>
 '(mode-line-inactive                  ((t (:foreground "<%= @base_fg.adjust_brightness(-20).html %>"  :background "<%= @base_bg.mix_with(@base_fg, 90).html %>" :box nil :weight light :inherit (mode-line)   ))))
 '(mode-line                           ((t (:foreground "<%= @base_fg.html %>"  :background "<%= @base_bg.mix_with(@base_fg, 90).html %>" :box nil ))))
<% else %>
 <% debug_out "Light theme modeline"  %>
 '(mode-line-inactive                  ((t (:foreground "<%= @base_fg.html %>"  :background "<%= @base_bg.adjust_brightness(-10).html %>" :box nil :weight light :inherit (mode-line)   ))))
 '(mode-line                           ((t (:foreground "<%= @base_fg.html %>"  :background "<%= @base_bg.adjust_brightness(-20).html %>" :box nil ))))
<% end %>

<%
# Search highlighting
%>
 '(isearch                             ((t (:foreground "#99ccee"  :background "#444444"                                               ))))
 '(isearch-fail                        ((t (                       :background "#ffaaaa"                                               ))))
 '(lazy-highlight                      ((t (                       :background "#77bbdd"                                               ))))
 '(match                               ((t (                       :background "#3388cc"                                               ))))

 '(tooltip                             ((t (:foreground "black"    :background "LightYellow" :inherit (variable-pitch)                 ))))

 '(js3-function-param-face             ((t (:foreground "#BFC3A9"                                                                      ))))
 '(js3-external-variable-face          ((t (:foreground "#F0B090"  :bold t                                                             ))))

 <%
 # TODO: Generate cua-rectangle and secondary-selection from region/selection import
 %>
 '(secondary-selection                 ((t (                       :background "#342858"                                               ))))
 '(cua-rectangle                       ((t (:foreground "#E0E4CC"  :background "#342858" ))))

 ;; Magit hightlight
 '(magit-item-highlight                ((t (:foreground "white" :background "#1278A8" :inherit nil ))))

 <%
 # TODO: Generate flyspell / flymake / flycheck / git:gutter from diff defaults/imported colors.
 %>
 ;; flyspell-mode
 '(flyspell-incorrect                  ((t (:underline "#AA0000" :background nil :inherit nil ))))
 '(flyspell-duplicate                  ((t (:underline "#009945" :background nil :inherit nil ))))

 ;; flymake-mode
 '(flymake-errline                     ((t (:underline "#AA0000" :background nil :inherit nil ))))
 '(flymake-warnline                    ((t (:underline "#009945" :background nil :inherit nil ))))

 ;;git-gutter
 '(git-gutter:added                    ((t (:foreground "#609f60" :bold t))))
 '(git-gutter:modified                 ((t (:foreground "#3388cc" :bold t))))
 '(git-gutter:deleted                  ((t (:foreground "#cc3333" :bold t))))

 '(diff-added                          ((t (:background "#305030"))))
 '(diff-removed                        ((t (:background "#903010"))))
 '(diff-file-header                    ((t (:background "#362145"))))
 '(diff-context                        ((t (:foreground "#E0E4CC"))))
 '(diff-changed                        ((t (:foreground "#3388cc"))))
 '(diff-hunk-header                    ((t (:background "#242130"))))

<%

# TODO: defaults should be overriden when the @emacs_faces below are
# evaluated, it'd be much cleaner if we managed it a better way.
# Perhaps keep the default faces as a hash and then merge the tmtheme
# imported faces hash, before writing out the face definitions.

# TODO: Infer color values of defaults based on the provided palette,
# using suitable tonal emphasis/de-emphasis as necessary. (this is
# being done "casually" for the modeline, fringe and linum)

%>

<% @emacs_faces.each do |e| debug_out e[:face] %>
 '(<%= e[:face] %> ((t (<%= face_attrs(e[:settings]) %>))))
<% end %>

<% if @rainbow_parens && @rainbow_parens.count == 10 %>
;; Rainbow delimiters
<% @rainbow_parens[0,9].each_with_index do |e,i| %>
 '(rainbow-delimiters-depth-<%= i + 1 %>-face ((t (:foreground "<%= e %>"))))
<% end %>
 '(rainbow-delimiters-unmatched-face ((t (:foreground "<%= @rainbow_parens[9] %>"))))
<% end %>
) ;; End face definitions

;;;###autoload
(when load-file-name
  (add-to-list 'custom-theme-load-path
               (file-name-as-directory (file-name-directory load-file-name))))

(provide-theme '<%= @theme_name %>)

;; Local Variables:
;; eval: (when (fboundp 'rainbow-mode) (rainbow-mode +1))
;; End:

;;; <%= @long_theme_name %>.el ends here
